package ru.runa.wfe.chat;

import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;

import static org.testng.Assert.assertEquals;

public class ChatEmailNotificationBuilderTest {

    @DataProvider
    public Object[][] getEndMoreMessageData() {
        return new Object[][]{
                {1, "новое сообщение"}, {2, "новых сообщения"}, {3, "новых сообщения"}, {4, "новых сообщения"},
                {5, "новых сообщений"}, {6, "новых сообщений"}, {7, "новых сообщений"}, {8, "новых сообщений"},
                {9, "новых сообщений"}, {10, "новых сообщений"}, {11, "новых сообщений"}, {12, "новых сообщений"},
                {13, "новых сообщений"}, {14, "новых сообщений"}, {15, "новых сообщений"}, {16, "новых сообщений"},
                {17, "новых сообщений"}, {18, "новых сообщений"}, {19, "новых сообщений"}, {20, "новых сообщений"},

                {21, "новое сообщение"}, {22, "новых сообщения"}, {23, "новых сообщения"}, {24, "новых сообщения"},
                {25, "новых сообщений"},

                {31, "новое сообщение"}, {32, "новых сообщения"}, {33, "новых сообщения"}, {34, "новых сообщения"},
                {35, "новых сообщений"},

                {41, "новое сообщение"}, {42, "новых сообщения"}, {43, "новых сообщения"}, {44, "новых сообщения"},
                {45, "новых сообщений"},

                {51, "новое сообщение"}, {52, "новых сообщения"}, {55, "новых сообщений"},
                {61, "новое сообщение"}, {62, "новых сообщения"}, {65, "новых сообщений"},
                {71, "новое сообщение"}, {72, "новых сообщения"}, {75, "новых сообщений"},
                {81, "новое сообщение"}, {82, "новых сообщения"}, {85, "новых сообщений"},
                {91, "новое сообщение"}, {92, "новых сообщения"}, {95, "новых сообщений"},

                {100, "новых сообщений"}, {101, "новое сообщение"}, {102, "новых сообщения"},
                {103, "новых сообщения"}, {104, "новых сообщения"}, {105, "новых сообщений"},

                {110, "новых сообщений"}, {111, "новых сообщений"}, {112, "новых сообщений"},
                {113, "новых сообщений"}, {114, "новых сообщений"}, {115, "новых сообщений"},

                {200, "новых сообщений"}, {201, "новое сообщение"}, {202, "новых сообщения"},
                {203, "новых сообщения"}, {204, "новых сообщения"}, {205, "новых сообщений"},

                {1000, "новых сообщений"}, {1001, "новое сообщение"}, {1002, "новых сообщения"},
                {1003, "новых сообщения"}, {1004, "новых сообщения"}, {1005, "новых сообщений"},
        };
    }

    @Test(dataProvider = "getEndMoreMessageData")
    public void givenNumberAndText_thenResultShouldEqualsTextDependingNumber(int number, String text) {
        ChatEmailNotificationBuilder builder = new ChatEmailNotificationBuilder();
        String result = builder.getTextDependingNumber(number,
                new String[] {"новое сообщение", "новых сообщения", "новых сообщений"});
        assertEquals(result, text);
    }
}