/*
 * This file is part of the RUNA WFE project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; version 2.1
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */
package ru.runa.common.web;

public class Resources {

    /* default local action forwards */
    public static final String FORWARD_SUCCESS = "success";
    public static final String FORWARD_FAILURE = "failure";

    /* CSS classes */
    public static final String CLASS_BOX = "box";
    public static final String CLASS_BOX_BODY = "box";
    public static final String CLASS_BOX_TITLE = "box";
    public final static String CLASS_TAB_CELL_SELECTED = "tab-selected";
    public final static String CLASS_GROUP_NAME = "group-name";
    public final static String CLASS_TAB_TABLE = "tab";
    public final static String CLASS_TAB_CELL = "tab";
    public static final String CLASS_LINK = "link";
    public static final String CLASS_PERMISSION_TABLE = "permissions";
    public static final String CLASS_PERMISSION_TABLE_TH = "permissions";
    public static final String CLASS_PERMISSION_TABLE_TD = "permissions";
    public static final String CLASS_LIST_TABLE = "list";
    public static final String CLASS_LIST_TABLE_TH = "list";
    public static final String CLASS_LIST_TABLE_TD = "list";
    public static final String CLASS_REQUIRED = "required";
    public static final String CLASS_INVALID = "invalid";
    public static final String CLASS_EMPTY20_TABLE_TD = "empty20";
    public static final String CLASS_ERROR = "error";
    public static final String CLASS_VIEW_SETUP_TABLE = "view-setup";
    public static final String CLASS_BUTTON = "button";
    public static final String CLASS_HIDEABLEBLOCK = "hideableblock";
    public static final String CLASS_PAGING_TABLE = "paging";
    public static final String CLASS_PAGING_NAVIGATION_TD = "paging-navigation";
    public static final String CLASS_PAGING_TOTAL_COUNT_TD = "paging-total-count";
    public static final String CLASS_FONT_RED = "fontRed";
    public static final String CLASS_SYMBOL = "symbol";
    public static final String HIDDEN_ALT = "[>]";
    public static final String VISIBLE_ALT = "[v]";
    public static final String HIDDEN_IMAGE = "/images/view_setup_hidden.gif";
    public static final String VISIBLE_IMAGE = "/images/view_setup_visible.gif";
    public static final String SORT_DESC_ALT = "[v]";
    public static final String SORT_ASC_ALT = "[^]";
    public static final String SORT_DESC_IMAGE = "/images/sort-d.gif";
    public static final String SORT_ASC_IMAGE = "/images/sort-a.gif";
    public static final String GROUP_PLUS_ALT = "[+]";
    public static final String GROUP_MINUS_ALT = "[-]";
    public static final String GROUP_PLUS_IMAGE = "/images/group_plus.gif";
    public static final String GROUP_MINUS_IMAGE = "/images/group_minus.gif";
    public static final String IMAGE_ATTACH = "/images/attach.png";
    public static final String IMAGE_DELETE = "/images/delete.png";
    public static final String IMAGE_LOADING = "/images/loading.gif";
    public static final String CLASS_SUSPENDED = "suspended";
    public static final String CLASS_EXECUTOR_GROUP = "executor_group";
    public static final String EXCEL_ICON = "/images/excel-icon.png";
    public static final String H_MORE_ICON = "/images/h-more-16.png";
    public static final String V_MORE_ICON = "/images/v-more-16.png";

    /* Chat actions */
    public static final String IMAGE_CHAT_DELETE = "/images/chat_delete.png";
    public static final String IMAGE_CHAT_EDIT = "/images/chat_edit.png";
    public static final String IMAGE_CHAT_REPLY = "/images/chat_reply.png";

    /* Data source specifics */
    public static final String ICON_DATA_SOURCE_EXCEL = "/images/MS-Excel-2013-icon.png";
    public static final String ICON_DATA_SOURCE_JDBC = "/images/jdbc_16.gif";
    public static final String ICON_DATA_SOURCE_JNDI = "/images/wildfly_icon_16.png";
    public static final String ICON_DATA_SOURCE_PASSWORD = "/images/lock-icon.png";
    public static final String ICON_DATA_SOURCE_SERVER_VERSION = "/images/information.png";

}
